---
name: Feature request
about: Use this template for raising a feature request
title: ''
labels: feature request
assignees: ''

---

**System information**

- TensorFlow version (you are using):
- Are you willing to contribute it (Yes/No):

**Motivation**

What is the use case and how does it broadly benefits users? Prioritization and whether a feature is added is based on how it
helps the community and the feature's maintenance costs.

As examples:

1. Instead of, "Enable the technique for my model," "Enable this technique to work better with standard object detection models, including R-CNN (link) and SSD (link)" is stronger.

2. Instead of, "Try something more customized with the technique," "Implement a variant of the algorithm described in equations X and Y of this paper" is clearer.

**Describe the feature**

**Describe how the feature helps achieve the use case**

**Describe how existing APIs don't satisfy your use case (optional if obvious)**

As examples:

1. You tried using APIs X and Y and were able to do Z. However, that was not sufficient because of ...

2. You achieved your use case with the code snippet W. However, this was more difficult than it should be because of ... (e.g. ran into issue X or had
   to do Y).
